// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"net/http"
	"strings"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/loads"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/runtime/middleware"
	"github.com/go-openapi/runtime/security"
	"github.com/go-openapi/spec"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/ansible"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/auth"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/dashboard"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/images"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/networks"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/roles"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/users"
	"gitlab.com/apricotsoft/public/infrastructure/vmdap/internal/transports/http/codegen/restapi/operations/virtual_machines"
)

// NewVMDAPAPI creates a new VMDAP instance
func NewVMDAPAPI(spec *loads.Document) *VMDAPAPI {
	return &VMDAPAPI{
		handlers:            make(map[string]map[string]http.Handler),
		formats:             strfmt.Default,
		defaultConsumes:     "application/json",
		defaultProduces:     "application/json",
		customConsumers:     make(map[string]runtime.Consumer),
		customProducers:     make(map[string]runtime.Producer),
		PreServerShutdown:   func() {},
		ServerShutdown:      func() {},
		spec:                spec,
		useSwaggerUI:        false,
		ServeError:          errors.ServeError,
		BasicAuthenticator:  security.BasicAuth,
		APIKeyAuthenticator: security.APIKeyAuth,
		BearerAuthenticator: security.BearerAuth,

		JSONConsumer: runtime.JSONConsumer(),

		JSONProducer: runtime.JSONProducer(),

		AnsibleAnsibleRoleGenerateHandler: ansible.AnsibleRoleGenerateHandlerFunc(func(params ansible.AnsibleRoleGenerateParams) middleware.Responder {
			return middleware.NotImplemented("operation ansible.AnsibleRoleGenerate has not yet been implemented")
		}),
		AnsibleAnsibleRoleTestHandler: ansible.AnsibleRoleTestHandlerFunc(func(params ansible.AnsibleRoleTestParams) middleware.Responder {
			return middleware.NotImplemented("operation ansible.AnsibleRoleTest has not yet been implemented")
		}),
		AuthAuthExchangeHandler: auth.AuthExchangeHandlerFunc(func(params auth.AuthExchangeParams) middleware.Responder {
			return middleware.NotImplemented("operation auth.AuthExchange has not yet been implemented")
		}),
		AuthAuthSignInHandler: auth.AuthSignInHandlerFunc(func(params auth.AuthSignInParams) middleware.Responder {
			return middleware.NotImplemented("operation auth.AuthSignIn has not yet been implemented")
		}),
		DashboardDashboardGetHandler: dashboard.DashboardGetHandlerFunc(func(params dashboard.DashboardGetParams) middleware.Responder {
			return middleware.NotImplemented("operation dashboard.DashboardGet has not yet been implemented")
		}),
		ImagesImageBuildHandler: images.ImageBuildHandlerFunc(func(params images.ImageBuildParams) middleware.Responder {
			return middleware.NotImplemented("operation images.ImageBuild has not yet been implemented")
		}),
		ImagesImageStatusHandler: images.ImageStatusHandlerFunc(func(params images.ImageStatusParams) middleware.Responder {
			return middleware.NotImplemented("operation images.ImageStatus has not yet been implemented")
		}),
		ImagesImageStopHandler: images.ImageStopHandlerFunc(func(params images.ImageStopParams) middleware.Responder {
			return middleware.NotImplemented("operation images.ImageStop has not yet been implemented")
		}),
		UsersUserCreateHandler: users.UserCreateHandlerFunc(func(params users.UserCreateParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserCreate has not yet been implemented")
		}),
		UsersUserDeleteHandler: users.UserDeleteHandlerFunc(func(params users.UserDeleteParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserDelete has not yet been implemented")
		}),
		UsersUserEditHandler: users.UserEditHandlerFunc(func(params users.UserEditParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserEdit has not yet been implemented")
		}),
		UsersUserGetHandler: users.UserGetHandlerFunc(func(params users.UserGetParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserGet has not yet been implemented")
		}),
		UsersUserGetSelfHandler: users.UserGetSelfHandlerFunc(func(params users.UserGetSelfParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserGetSelf has not yet been implemented")
		}),
		UsersUserListHandler: users.UserListHandlerFunc(func(params users.UserListParams) middleware.Responder {
			return middleware.NotImplemented("operation users.UserList has not yet been implemented")
		}),
		RolesUserRoleCreateHandler: roles.UserRoleCreateHandlerFunc(func(params roles.UserRoleCreateParams) middleware.Responder {
			return middleware.NotImplemented("operation roles.UserRoleCreate has not yet been implemented")
		}),
		RolesUserRoleDeleteHandler: roles.UserRoleDeleteHandlerFunc(func(params roles.UserRoleDeleteParams) middleware.Responder {
			return middleware.NotImplemented("operation roles.UserRoleDelete has not yet been implemented")
		}),
		RolesUserRoleEditHandler: roles.UserRoleEditHandlerFunc(func(params roles.UserRoleEditParams) middleware.Responder {
			return middleware.NotImplemented("operation roles.UserRoleEdit has not yet been implemented")
		}),
		RolesUserRoleGetHandler: roles.UserRoleGetHandlerFunc(func(params roles.UserRoleGetParams) middleware.Responder {
			return middleware.NotImplemented("operation roles.UserRoleGet has not yet been implemented")
		}),
		RolesUserRoleListHandler: roles.UserRoleListHandlerFunc(func(params roles.UserRoleListParams) middleware.Responder {
			return middleware.NotImplemented("operation roles.UserRoleList has not yet been implemented")
		}),
		VirtualMachinesVMCreateHandler: virtual_machines.VMCreateHandlerFunc(func(params virtual_machines.VMCreateParams) middleware.Responder {
			return middleware.NotImplemented("operation virtual_machines.VMCreate has not yet been implemented")
		}),
		VirtualMachinesVMDeleteHandler: virtual_machines.VMDeleteHandlerFunc(func(params virtual_machines.VMDeleteParams) middleware.Responder {
			return middleware.NotImplemented("operation virtual_machines.VMDelete has not yet been implemented")
		}),
		VirtualMachinesVMEditHandler: virtual_machines.VMEditHandlerFunc(func(params virtual_machines.VMEditParams) middleware.Responder {
			return middleware.NotImplemented("operation virtual_machines.VMEdit has not yet been implemented")
		}),
		VirtualMachinesVMGetHandler: virtual_machines.VMGetHandlerFunc(func(params virtual_machines.VMGetParams) middleware.Responder {
			return middleware.NotImplemented("operation virtual_machines.VMGet has not yet been implemented")
		}),
		VirtualMachinesVMListHandler: virtual_machines.VMListHandlerFunc(func(params virtual_machines.VMListParams) middleware.Responder {
			return middleware.NotImplemented("operation virtual_machines.VMList has not yet been implemented")
		}),
		NetworksVMNetworkCreateHandler: networks.VMNetworkCreateHandlerFunc(func(params networks.VMNetworkCreateParams) middleware.Responder {
			return middleware.NotImplemented("operation networks.VMNetworkCreate has not yet been implemented")
		}),
		NetworksVMNetworkDeleteHandler: networks.VMNetworkDeleteHandlerFunc(func(params networks.VMNetworkDeleteParams) middleware.Responder {
			return middleware.NotImplemented("operation networks.VMNetworkDelete has not yet been implemented")
		}),
		NetworksVMNetworkEditHandler: networks.VMNetworkEditHandlerFunc(func(params networks.VMNetworkEditParams) middleware.Responder {
			return middleware.NotImplemented("operation networks.VMNetworkEdit has not yet been implemented")
		}),
		NetworksVMNetworkGetHandler: networks.VMNetworkGetHandlerFunc(func(params networks.VMNetworkGetParams) middleware.Responder {
			return middleware.NotImplemented("operation networks.VMNetworkGet has not yet been implemented")
		}),
		NetworksVMNetworkListHandler: networks.VMNetworkListHandlerFunc(func(params networks.VMNetworkListParams) middleware.Responder {
			return middleware.NotImplemented("operation networks.VMNetworkList has not yet been implemented")
		}),
	}
}

/*VMDAPAPI VMDAP API for manage virtual machine deployment */
type VMDAPAPI struct {
	spec            *loads.Document
	context         *middleware.Context
	handlers        map[string]map[string]http.Handler
	formats         strfmt.Registry
	customConsumers map[string]runtime.Consumer
	customProducers map[string]runtime.Producer
	defaultConsumes string
	defaultProduces string
	Middleware      func(middleware.Builder) http.Handler
	useSwaggerUI    bool

	// BasicAuthenticator generates a runtime.Authenticator from the supplied basic auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BasicAuthenticator func(security.UserPassAuthentication) runtime.Authenticator
	// APIKeyAuthenticator generates a runtime.Authenticator from the supplied token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	APIKeyAuthenticator func(string, string, security.TokenAuthentication) runtime.Authenticator
	// BearerAuthenticator generates a runtime.Authenticator from the supplied bearer token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BearerAuthenticator func(string, security.ScopedTokenAuthentication) runtime.Authenticator

	// JSONConsumer registers a consumer for the following mime types:
	//   - application/json
	JSONConsumer runtime.Consumer

	// JSONProducer registers a producer for the following mime types:
	//   - application/json
	JSONProducer runtime.Producer

	// AnsibleAnsibleRoleGenerateHandler sets the operation handler for the ansible role generate operation
	AnsibleAnsibleRoleGenerateHandler ansible.AnsibleRoleGenerateHandler
	// AnsibleAnsibleRoleTestHandler sets the operation handler for the ansible role test operation
	AnsibleAnsibleRoleTestHandler ansible.AnsibleRoleTestHandler
	// AuthAuthExchangeHandler sets the operation handler for the auth exchange operation
	AuthAuthExchangeHandler auth.AuthExchangeHandler
	// AuthAuthSignInHandler sets the operation handler for the auth sign in operation
	AuthAuthSignInHandler auth.AuthSignInHandler
	// DashboardDashboardGetHandler sets the operation handler for the dashboard get operation
	DashboardDashboardGetHandler dashboard.DashboardGetHandler
	// ImagesImageBuildHandler sets the operation handler for the image build operation
	ImagesImageBuildHandler images.ImageBuildHandler
	// ImagesImageStatusHandler sets the operation handler for the image status operation
	ImagesImageStatusHandler images.ImageStatusHandler
	// ImagesImageStopHandler sets the operation handler for the image stop operation
	ImagesImageStopHandler images.ImageStopHandler
	// UsersUserCreateHandler sets the operation handler for the user create operation
	UsersUserCreateHandler users.UserCreateHandler
	// UsersUserDeleteHandler sets the operation handler for the user delete operation
	UsersUserDeleteHandler users.UserDeleteHandler
	// UsersUserEditHandler sets the operation handler for the user edit operation
	UsersUserEditHandler users.UserEditHandler
	// UsersUserGetHandler sets the operation handler for the user get operation
	UsersUserGetHandler users.UserGetHandler
	// UsersUserGetSelfHandler sets the operation handler for the user get self operation
	UsersUserGetSelfHandler users.UserGetSelfHandler
	// UsersUserListHandler sets the operation handler for the user list operation
	UsersUserListHandler users.UserListHandler
	// RolesUserRoleCreateHandler sets the operation handler for the user role create operation
	RolesUserRoleCreateHandler roles.UserRoleCreateHandler
	// RolesUserRoleDeleteHandler sets the operation handler for the user role delete operation
	RolesUserRoleDeleteHandler roles.UserRoleDeleteHandler
	// RolesUserRoleEditHandler sets the operation handler for the user role edit operation
	RolesUserRoleEditHandler roles.UserRoleEditHandler
	// RolesUserRoleGetHandler sets the operation handler for the user role get operation
	RolesUserRoleGetHandler roles.UserRoleGetHandler
	// RolesUserRoleListHandler sets the operation handler for the user role list operation
	RolesUserRoleListHandler roles.UserRoleListHandler
	// VirtualMachinesVMCreateHandler sets the operation handler for the vm create operation
	VirtualMachinesVMCreateHandler virtual_machines.VMCreateHandler
	// VirtualMachinesVMDeleteHandler sets the operation handler for the vm delete operation
	VirtualMachinesVMDeleteHandler virtual_machines.VMDeleteHandler
	// VirtualMachinesVMEditHandler sets the operation handler for the vm edit operation
	VirtualMachinesVMEditHandler virtual_machines.VMEditHandler
	// VirtualMachinesVMGetHandler sets the operation handler for the vm get operation
	VirtualMachinesVMGetHandler virtual_machines.VMGetHandler
	// VirtualMachinesVMListHandler sets the operation handler for the vm list operation
	VirtualMachinesVMListHandler virtual_machines.VMListHandler
	// NetworksVMNetworkCreateHandler sets the operation handler for the vm network create operation
	NetworksVMNetworkCreateHandler networks.VMNetworkCreateHandler
	// NetworksVMNetworkDeleteHandler sets the operation handler for the vm network delete operation
	NetworksVMNetworkDeleteHandler networks.VMNetworkDeleteHandler
	// NetworksVMNetworkEditHandler sets the operation handler for the vm network edit operation
	NetworksVMNetworkEditHandler networks.VMNetworkEditHandler
	// NetworksVMNetworkGetHandler sets the operation handler for the vm network get operation
	NetworksVMNetworkGetHandler networks.VMNetworkGetHandler
	// NetworksVMNetworkListHandler sets the operation handler for the vm network list operation
	NetworksVMNetworkListHandler networks.VMNetworkListHandler
	// ServeError is called when an error is received, there is a default handler
	// but you can set your own with this
	ServeError func(http.ResponseWriter, *http.Request, error)

	// PreServerShutdown is called before the HTTP(S) server is shutdown
	// This allows for custom functions to get executed before the HTTP(S) server stops accepting traffic
	PreServerShutdown func()

	// ServerShutdown is called when the HTTP(S) server is shut down and done
	// handling all active connections and does not accept connections any more
	ServerShutdown func()

	// Custom command line argument groups with their descriptions
	CommandLineOptionsGroups []swag.CommandLineOptionsGroup

	// User defined logger function.
	Logger func(string, ...interface{})
}

// UseRedoc for documentation at /docs
func (o *VMDAPAPI) UseRedoc() {
	o.useSwaggerUI = false
}

// UseSwaggerUI for documentation at /docs
func (o *VMDAPAPI) UseSwaggerUI() {
	o.useSwaggerUI = true
}

// SetDefaultProduces sets the default produces media type
func (o *VMDAPAPI) SetDefaultProduces(mediaType string) {
	o.defaultProduces = mediaType
}

// SetDefaultConsumes returns the default consumes media type
func (o *VMDAPAPI) SetDefaultConsumes(mediaType string) {
	o.defaultConsumes = mediaType
}

// SetSpec sets a spec that will be served for the clients.
func (o *VMDAPAPI) SetSpec(spec *loads.Document) {
	o.spec = spec
}

// DefaultProduces returns the default produces media type
func (o *VMDAPAPI) DefaultProduces() string {
	return o.defaultProduces
}

// DefaultConsumes returns the default consumes media type
func (o *VMDAPAPI) DefaultConsumes() string {
	return o.defaultConsumes
}

// Formats returns the registered string formats
func (o *VMDAPAPI) Formats() strfmt.Registry {
	return o.formats
}

// RegisterFormat registers a custom format validator
func (o *VMDAPAPI) RegisterFormat(name string, format strfmt.Format, validator strfmt.Validator) {
	o.formats.Add(name, format, validator)
}

// Validate validates the registrations in the VMDAPAPI
func (o *VMDAPAPI) Validate() error {
	var unregistered []string

	if o.JSONConsumer == nil {
		unregistered = append(unregistered, "JSONConsumer")
	}

	if o.JSONProducer == nil {
		unregistered = append(unregistered, "JSONProducer")
	}

	if o.AnsibleAnsibleRoleGenerateHandler == nil {
		unregistered = append(unregistered, "ansible.AnsibleRoleGenerateHandler")
	}
	if o.AnsibleAnsibleRoleTestHandler == nil {
		unregistered = append(unregistered, "ansible.AnsibleRoleTestHandler")
	}
	if o.AuthAuthExchangeHandler == nil {
		unregistered = append(unregistered, "auth.AuthExchangeHandler")
	}
	if o.AuthAuthSignInHandler == nil {
		unregistered = append(unregistered, "auth.AuthSignInHandler")
	}
	if o.DashboardDashboardGetHandler == nil {
		unregistered = append(unregistered, "dashboard.DashboardGetHandler")
	}
	if o.ImagesImageBuildHandler == nil {
		unregistered = append(unregistered, "images.ImageBuildHandler")
	}
	if o.ImagesImageStatusHandler == nil {
		unregistered = append(unregistered, "images.ImageStatusHandler")
	}
	if o.ImagesImageStopHandler == nil {
		unregistered = append(unregistered, "images.ImageStopHandler")
	}
	if o.UsersUserCreateHandler == nil {
		unregistered = append(unregistered, "users.UserCreateHandler")
	}
	if o.UsersUserDeleteHandler == nil {
		unregistered = append(unregistered, "users.UserDeleteHandler")
	}
	if o.UsersUserEditHandler == nil {
		unregistered = append(unregistered, "users.UserEditHandler")
	}
	if o.UsersUserGetHandler == nil {
		unregistered = append(unregistered, "users.UserGetHandler")
	}
	if o.UsersUserGetSelfHandler == nil {
		unregistered = append(unregistered, "users.UserGetSelfHandler")
	}
	if o.UsersUserListHandler == nil {
		unregistered = append(unregistered, "users.UserListHandler")
	}
	if o.RolesUserRoleCreateHandler == nil {
		unregistered = append(unregistered, "roles.UserRoleCreateHandler")
	}
	if o.RolesUserRoleDeleteHandler == nil {
		unregistered = append(unregistered, "roles.UserRoleDeleteHandler")
	}
	if o.RolesUserRoleEditHandler == nil {
		unregistered = append(unregistered, "roles.UserRoleEditHandler")
	}
	if o.RolesUserRoleGetHandler == nil {
		unregistered = append(unregistered, "roles.UserRoleGetHandler")
	}
	if o.RolesUserRoleListHandler == nil {
		unregistered = append(unregistered, "roles.UserRoleListHandler")
	}
	if o.VirtualMachinesVMCreateHandler == nil {
		unregistered = append(unregistered, "virtual_machines.VMCreateHandler")
	}
	if o.VirtualMachinesVMDeleteHandler == nil {
		unregistered = append(unregistered, "virtual_machines.VMDeleteHandler")
	}
	if o.VirtualMachinesVMEditHandler == nil {
		unregistered = append(unregistered, "virtual_machines.VMEditHandler")
	}
	if o.VirtualMachinesVMGetHandler == nil {
		unregistered = append(unregistered, "virtual_machines.VMGetHandler")
	}
	if o.VirtualMachinesVMListHandler == nil {
		unregistered = append(unregistered, "virtual_machines.VMListHandler")
	}
	if o.NetworksVMNetworkCreateHandler == nil {
		unregistered = append(unregistered, "networks.VMNetworkCreateHandler")
	}
	if o.NetworksVMNetworkDeleteHandler == nil {
		unregistered = append(unregistered, "networks.VMNetworkDeleteHandler")
	}
	if o.NetworksVMNetworkEditHandler == nil {
		unregistered = append(unregistered, "networks.VMNetworkEditHandler")
	}
	if o.NetworksVMNetworkGetHandler == nil {
		unregistered = append(unregistered, "networks.VMNetworkGetHandler")
	}
	if o.NetworksVMNetworkListHandler == nil {
		unregistered = append(unregistered, "networks.VMNetworkListHandler")
	}

	if len(unregistered) > 0 {
		return fmt.Errorf("missing registration: %s", strings.Join(unregistered, ", "))
	}

	return nil
}

// ServeErrorFor gets a error handler for a given operation id
func (o *VMDAPAPI) ServeErrorFor(operationID string) func(http.ResponseWriter, *http.Request, error) {
	return o.ServeError
}

// AuthenticatorsFor gets the authenticators for the specified security schemes
func (o *VMDAPAPI) AuthenticatorsFor(schemes map[string]spec.SecurityScheme) map[string]runtime.Authenticator {
	return nil
}

// Authorizer returns the registered authorizer
func (o *VMDAPAPI) Authorizer() runtime.Authorizer {
	return nil
}

// ConsumersFor gets the consumers for the specified media types.
// MIME type parameters are ignored here.
func (o *VMDAPAPI) ConsumersFor(mediaTypes []string) map[string]runtime.Consumer {
	result := make(map[string]runtime.Consumer, len(mediaTypes))
	for _, mt := range mediaTypes {
		switch mt {
		case "application/json":
			result["application/json"] = o.JSONConsumer
		}

		if c, ok := o.customConsumers[mt]; ok {
			result[mt] = c
		}
	}
	return result
}

// ProducersFor gets the producers for the specified media types.
// MIME type parameters are ignored here.
func (o *VMDAPAPI) ProducersFor(mediaTypes []string) map[string]runtime.Producer {
	result := make(map[string]runtime.Producer, len(mediaTypes))
	for _, mt := range mediaTypes {
		switch mt {
		case "application/json":
			result["application/json"] = o.JSONProducer
		}

		if p, ok := o.customProducers[mt]; ok {
			result[mt] = p
		}
	}
	return result
}

// HandlerFor gets a http.Handler for the provided operation method and path
func (o *VMDAPAPI) HandlerFor(method, path string) (http.Handler, bool) {
	if o.handlers == nil {
		return nil, false
	}
	um := strings.ToUpper(method)
	if _, ok := o.handlers[um]; !ok {
		return nil, false
	}
	if path == "/" {
		path = ""
	}
	h, ok := o.handlers[um][path]
	return h, ok
}

// Context returns the middleware context for the VM d a p API
func (o *VMDAPAPI) Context() *middleware.Context {
	if o.context == nil {
		o.context = middleware.NewRoutableContext(o.spec, o, nil)
	}

	return o.context
}

func (o *VMDAPAPI) initHandlerCache() {
	o.Context() // don't care about the result, just that the initialization happened
	if o.handlers == nil {
		o.handlers = make(map[string]map[string]http.Handler)
	}

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/ansible/generate"] = ansible.NewAnsibleRoleGenerate(o.context, o.AnsibleAnsibleRoleGenerateHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/ansible/test"] = ansible.NewAnsibleRoleTest(o.context, o.AnsibleAnsibleRoleTestHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/auth/exchange"] = auth.NewAuthExchange(o.context, o.AuthAuthExchangeHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/auth"] = auth.NewAuthSignIn(o.context, o.AuthAuthSignInHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/dashboard"] = dashboard.NewDashboardGet(o.context, o.DashboardDashboardGetHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/images"] = images.NewImageBuild(o.context, o.ImagesImageBuildHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/images/{id}"] = images.NewImageStatus(o.context, o.ImagesImageStatusHandler)
	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/api/images/{id}"] = images.NewImageStop(o.context, o.ImagesImageStopHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/users"] = users.NewUserCreate(o.context, o.UsersUserCreateHandler)
	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/api/users/{id}"] = users.NewUserDelete(o.context, o.UsersUserDeleteHandler)
	if o.handlers["PUT"] == nil {
		o.handlers["PUT"] = make(map[string]http.Handler)
	}
	o.handlers["PUT"]["/api/users/{id}"] = users.NewUserEdit(o.context, o.UsersUserEditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/users/{id}"] = users.NewUserGet(o.context, o.UsersUserGetHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/users/self"] = users.NewUserGetSelf(o.context, o.UsersUserGetSelfHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/users"] = users.NewUserList(o.context, o.UsersUserListHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/roles"] = roles.NewUserRoleCreate(o.context, o.RolesUserRoleCreateHandler)
	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/api/roles/{id}"] = roles.NewUserRoleDelete(o.context, o.RolesUserRoleDeleteHandler)
	if o.handlers["PUT"] == nil {
		o.handlers["PUT"] = make(map[string]http.Handler)
	}
	o.handlers["PUT"]["/api/roles/{id}"] = roles.NewUserRoleEdit(o.context, o.RolesUserRoleEditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/roles/{id}"] = roles.NewUserRoleGet(o.context, o.RolesUserRoleGetHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/roles"] = roles.NewUserRoleList(o.context, o.RolesUserRoleListHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/vms"] = virtual_machines.NewVMCreate(o.context, o.VirtualMachinesVMCreateHandler)
	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/api/vms/{id}"] = virtual_machines.NewVMDelete(o.context, o.VirtualMachinesVMDeleteHandler)
	if o.handlers["PUT"] == nil {
		o.handlers["PUT"] = make(map[string]http.Handler)
	}
	o.handlers["PUT"]["/api/vms/{id}"] = virtual_machines.NewVMEdit(o.context, o.VirtualMachinesVMEditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/vms/{id}"] = virtual_machines.NewVMGet(o.context, o.VirtualMachinesVMGetHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/vms"] = virtual_machines.NewVMList(o.context, o.VirtualMachinesVMListHandler)
	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/api/networks"] = networks.NewVMNetworkCreate(o.context, o.NetworksVMNetworkCreateHandler)
	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/api/networks/{id}"] = networks.NewVMNetworkDelete(o.context, o.NetworksVMNetworkDeleteHandler)
	if o.handlers["PUT"] == nil {
		o.handlers["PUT"] = make(map[string]http.Handler)
	}
	o.handlers["PUT"]["/api/networks/{id}"] = networks.NewVMNetworkEdit(o.context, o.NetworksVMNetworkEditHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/networks/{id}"] = networks.NewVMNetworkGet(o.context, o.NetworksVMNetworkGetHandler)
	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/api/networks"] = networks.NewVMNetworkList(o.context, o.NetworksVMNetworkListHandler)
}

// Serve creates a http handler to serve the API over HTTP
// can be used directly in http.ListenAndServe(":8000", api.Serve(nil))
func (o *VMDAPAPI) Serve(builder middleware.Builder) http.Handler {
	o.Init()

	if o.Middleware != nil {
		return o.Middleware(builder)
	}
	if o.useSwaggerUI {
		return o.context.APIHandlerSwaggerUI(builder)
	}
	return o.context.APIHandler(builder)
}

// Init allows you to just initialize the handler cache, you can then recompose the middleware as you see fit
func (o *VMDAPAPI) Init() {
	if len(o.handlers) == 0 {
		o.initHandlerCache()
	}
}

// RegisterConsumer allows you to add (or override) a consumer for a media type.
func (o *VMDAPAPI) RegisterConsumer(mediaType string, consumer runtime.Consumer) {
	o.customConsumers[mediaType] = consumer
}

// RegisterProducer allows you to add (or override) a producer for a media type.
func (o *VMDAPAPI) RegisterProducer(mediaType string, producer runtime.Producer) {
	o.customProducers[mediaType] = producer
}

// AddMiddlewareFor adds a http middleware to existing handler
func (o *VMDAPAPI) AddMiddlewareFor(method, path string, builder middleware.Builder) {
	um := strings.ToUpper(method)
	if path == "/" {
		path = ""
	}
	o.Init()
	if h, ok := o.handlers[um][path]; ok {
		o.handlers[method][path] = builder(h)
	}
}
